//////////////////////////////////////
// Program Name: Cleantmp.exe
// Programmer: Brad Kiefer
// Description: processes all volumes and deletes temporary files
//////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <alloc.h>
#include <dos.h>
#include <bios.h>
#include <dir.h>
#include <dlgs.h>
#include <io.h>
#include <dlgs.h>			        // header for control defines
#include <shellapi.h>           // for Send to Recycle Bin

#include "cleantmp.h"

//#pragma hdrstop

#if !defined(__WIN32__) && !defined(_WIN32)
#define EXPORT16 __export
#else
#define EXPORT16
#endif

BOOL CenterWindow (HWND hwndChild, HWND hwndParent);
LRESULT CALLBACK EXPORT16 WndProc(HWND hWindow, UINT Message, WPARAM wParam, LPARAM lParam);

#pragma warning (disable: 4068)
#pragma warning (disable: 4100)


static char szAppName[] = "Clean ALL temporary files from ALL Hard Drives";
static HWND hMainWindow;

static HINSTANCE hWInst;

HWND hList = NULL;
HWND hDlgSearch = NULL;
Bool stopkey;


char RootDir[260] = "C:\\";      // current directory

char   text[260]={0};

static char *deletenames[16] =    //
{
  "TMP",          	//  Temp Files
  "BAK",					//  Backup files
  "VIR",					//  Virus Files
  "CNT",					//  Help Temp. Files
  "CHK",          	//  CHECKDISK
  "GRP",					//  GROUP FILES
  "GID",					//  HELP FILES
  "CSM",					//  COMPILIED HEADERS
  "FTS",          	//  ??
  "~MP",					//  Backup files
  "BMK",					//  BACKUP Files
  "$$$",					//  Temp. Files
  "OLD",             //  Temp. Files
  "_DD",             //  Norton Disk Doctor
  "TEMP",            //  TEMP  !!! 4 digits NOT supported yet
  "",						//  User set
};


int   maxclean = 14;				// # of extensions to match and delete
int   maxgood = 8;				// # of extensions we want to keep !

/*
static char *goodnames[8] =    //
{
  "COM",          	//  Command Files
  "EXE",					//  Executable files
  "BAT",					//  Batch Files
  "CFG",					//  Config Files
  "SYS",					//  System Files
  "DLL",					//  DLL Dynamic Link Libraries
  "VXD",					//  Virtual Device Drivers
  "HLP"              //  Help Files
};
*/


// ===================================
// INITIALIZATION
// ===================================


//////////////////////////////////////
// The WinMain function is the program entry point.
// Register the Window, Create it, enter the Message Loop.
// If either step fails, exit without creating the window
//////////////////////////////////////
#pragma argsused
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance,
                   LPSTR lpszCmdParam, int nCmdShow)
{
  MSG  Msg;

  if (!hPrevInstance)
    if (!Register(hInst))
      return FALSE;

  hMainWindow = Create(hInst, nCmdShow);
  hWInst  =  hInst;

  if (!hMainWindow)
    return FALSE;

  while (GetMessage(&Msg, NULL, 0, 0))
  {
     TranslateMessage(&Msg);
     DispatchMessage(&Msg);
  }

  return Msg.wParam;
}

//////////////////////////////////////
// Register the window
//////////////////////////////////////
BOOL Register(HINSTANCE hInst)
{
  /* You can use WNDCLASSEX and RegisterClassEx with WIN32 */

  WNDCLASS WndClass;

  WndClass.style         = CS_HREDRAW | CS_VREDRAW;
  WndClass.lpfnWndProc   = WndProc;
  WndClass.cbClsExtra    = 0;
  WndClass.cbWndExtra    = 0;
  WndClass.hInstance     = hInst;
  WndClass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  WndClass.hCursor       = LoadCursor(NULL, IDC_WAIT);
  WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  WndClass.lpszMenuName  = NULL;
  WndClass.lpszClassName = szAppName;

  return (RegisterClass(&WndClass) != 0);
}


//////////////////////////////////////
// Create the window
//////////////////////////////////////
#pragma argsused
HWND Create(HINSTANCE hInstance, int nCmdShow)
{
  HWND hWindow = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW | WS_EX_DLGMODALFRAME, szAppName, szAppName,
                    WS_OVERLAPPEDWINDOW | WS_VISIBLE ,
                    100,100,180, 180,
                    NULL, NULL, hInstance, NULL);

  if (hWindow == NULL)
    return hWindow;

  ShowWindow(hWindow, SW_SHOWDEFAULT);
  UpdateWindow(hWindow);

  return hWindow;
}



//---------------------------------------------------------------------------
// Ask to confirm a choice (message box)    Yes, No
// If you create a message box while a dialog box is present,
// use the handle of the dialog box as the hWnd parameter.
// The hWnd parameter should not identify a child window, such as a control in a dialog box.
//---------------------------------------------------------------------------
BOOL Confirm(HWND hwnd, char *confstr, ...)
{
	char msg[1024];
   char *pArgs;	   // Pointer to arguments

   pArgs = (char *) &confstr + sizeof (confstr);    // find it

	vsprintf(msg, confstr, pArgs);						  // format it

	int ans = MessageBox (hwnd, msg, "Confirm",
                         MB_YESNO | MB_ICONQUESTION | MB_TASKMODAL | MB_APPLMODAL |MB_SETFOREGROUND);

	return ((ans == IDYES) ? TRUE : FALSE);
}


/////////////////////////////////////////////////////////////////////////////
// Create Window
/////////////////////////////////////////////////////////////////////////////

#pragma argsused
BOOL Q2_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
  PostMessage(hwnd, WM_COMMAND, WM_STARTUP, 0);	// Ordinary Startup
  return TRUE;
}



///////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
void Q2_Command(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
  	int2  	key;
//   char   name[4]={0};
//   char   testname[4]={0};

  switch(id)
  {

   case WM_STARTUP:

       CenterWindow(hwnd , GetDesktopWindow());

       key = (int2)MessageBox(hwnd, "This program will will find ALL occurances\n"
       										"of the following files :\n"
                                    "-  tmp, bak, vir, cnt, chk \n"
                                    "-  grp, gid, csm, fts, temp \n"
                                    "-  ~mp, $$$, old, and  _dd\n"
                                    "on ALL local partitions and Hard Drives\n"
                                    "and then DELETE them !!\n\n"
                                    "Press OK to continue,  or CANCEL to exit now", "Delete Temp Program",MB_OKCANCEL);
       if (key == IDCANCEL)
         {
           PostQuitMessage(0);
         }
       else
       	{

/*
           if (!InputUserText (hwnd, 3, name, UPPERCASE) ||  name[0] == '\0')
            {
              maxclean = --maxclean;
            }
           else
            {
             // Compare the extension to known GOOD extension so we
             // don't do anything too hasty like wipe all com or exe files !

              // maxclean = 5;
              lstrcpyn(deletenames[maxclean], name, 4);

             for(f=0; f<maxgood; f++)
              {
                lstrcpyn(testname, goodnames[f],4);		// Grab our extensions 1 at a time

	            if (!strcmp (testname, name) )
	             {
                   maxclean = --maxclean;                // BAD BAD BOY - only Clean
						 deletenames[maxclean] = '\0';
                   break;                                // Our known extensions
	             }
              }
            }

*/
              AutoSearch();

              MessageBox(hwnd, 		"                      ALL DONE\n\n"
              								"You can move this dialog box\n"
                                    "Out of the Way and browse the files\n"
                                    "That have been deleted by moving the\n"
                                    "Scroll bar on the right hand side of the Window.\n\n\n"
                                    "When Done - Click THIS OK Button to EXIT\n\n"
                                    "NOTE :  File Error 1026 means that the file\n"
                                    "was marked as READ ONLY by Windows\n\n"
                                    "A lot of .cnt ( table of CoNTents )\n"
                                    "files are marked RO, but could be deleted.\n"
                                    "Files marked RO are NOT deleted but you could\n"
                                    "take the RO attribute off through Windows Explorer\n\n"
                                    "ALL FILES now go to your RECYCLE BIN\n"
                                    "So, you MUST Right Click on your Recycle Bin\n"
                                    "and choose Empty Recycle Bin from the popup menu\n"
                                    "otherwise they are still taking up disk space !", "Delete Temp Program   by  BK.",MB_OK);

              PostQuitMessage(0);

         }

     break;
  }
}

//////////////////////////////////////
// Handle WM_DESTROY message
//////////////////////////////////////
#pragma argsused
void Q2_OnDestroy(HWND hwnd)
{
  if(hDlgSearch) DestroyWindow(hDlgSearch); // get rid of the dialog
  PostQuitMessage(0);
}



//-----------------------------------------------------------------------------
// process the directory, look for filename
//-----------------------------------------------------------------------------

char * ProcessDirectory(char*drive,char*dir,char*filename,char*ext)
{

struct ffblk ffblk;
SHFILEOPSTRUCT op;

       int2  n;
       Bool  done;
       BOOL  deleted;
//       BOOL  OKtoDelete;
static BOOL  NumDeleted;

       char  NumDelString [64] = {0};
       char  NameCheck[9] = {0};
       char  CurrentPath [260];
static char  TempFileName[260];  // static reqd for return
       char  RecycleName[] = "RECYCLED";

//       char  name[4]={0};

//----------------------------------------------------------------

    strcpy (CurrentPath,drive);
    strcat (CurrentPath,dir);
    strcat (CurrentPath,filename);
    strcat (CurrentPath,ext);

    done = (int2)findfirst(CurrentPath,&ffblk,DIRFILEA);     // find first member (no dirs)

    strcpy (CurrentPath,drive);
    strcat (CurrentPath,dir);

    while (!done)
    {
      if (!(ffblk.ff_attrib & FA_DIREC ) ) // not directory file
      {
	  		strcpy (TempFileName,CurrentPath);
	  		strcat (TempFileName,ffblk.ff_name);    // name,suffix
         strcat (TempFileName, "\0\0");          // double NULL Terminate

          for(n=0;n < 8; n++)
           {
            NameCheck[n]= TempFileName[n+3];
           }

          strcat(NameCheck, "\0");

          //  Don't need to Delete from The Recyle Bin
	       if (!lstrcmp (RecycleName, NameCheck) )
          {
             return NULL;
          }

         // Initial Code to compare filename with user defined extensions
         // to delete -  needless to say when someone put a * in the ext.
         // it didn't do their files any good - so I removed that portion.


			//wsprintf(text," %s  OR  %s.%s", TempFileName,filename,ext);
         /*
             for(f=0; f<maxgood; f++)
              { lstrcpyn(name, goodnames[f],4);		// Grab our extensions 1 at a time
                OKtoDelete = 1;

	            if (!strcmp (ffblk.ff_name, name) )
	             {  OKtoDelete = 0;
                   break;                                // Our known extensions
	             }
              }
          if (OKtoDelete)
           {  deleted = DeleteFile(TempFileName);
              sleep(1000);
           }
         */

   // Note Requires a double null terminate.
   // IF you use wildcards, the files will get deleted, but they won't show up
   // in the recycle-bin.

        ZeroMemory(&op,sizeof(op));

        op.hwnd=hMainWindow;
        op.wFunc=FO_DELETE;
        op.pFrom=TempFileName;          // double null terminate
        op.fFlags=FOF_ALLOWUNDO|FOF_NOCONFIRMATION;

        // Returns 0 if success else nonzero on error
        deleted = SHFileOperation(&op);


          if (!deleted)
           {
               NumDeleted++;

               ListBox_AddString(hList, TempFileName);  // listbox1

			      wsprintf(NumDelString,"%d  Deleted", NumDeleted);
               Static_SetText(GetDlgItem(hDlgSearch, stc3), NumDelString);
               UpdateWindow(GetDlgItem(hDlgSearch, stc3));
           }
          //else
          // {
             //wsprintf(text," !! %s !!,  NOT  Deleted", TempFileName);
	          //MessageBox (hMainWindow, text, "For Your Information", MB_OK | MB_ICONQUESTION | MB_TASKMODAL);
          // }
          }

      done = (int2)findnext(&ffblk);
    }


    return NULL;
}

//--------------------------------------------------------------------------
// process directory, looking for filenames and directories
//--------------------------------------------------------------------------

ProcessVolume(char*drive,char*dir,char*filename,char*ext)
{
struct ffblk ffblk;

   Bool  done;
   Bool  DidDir = FALSE;

   char  CurrentPath [260]={0};
   char  TempFileName[260]={0};

   strcpy (CurrentPath,drive);
   strcat (CurrentPath,dir);
   strcat (CurrentPath,"*.*");

   MSG   keymsg;
//------------------------------------------------------

   keymsg.message = 0;

   Static_SetText(GetDlgItem(hDlgSearch, stc1), CurrentPath);

   done = (int2)findfirst(CurrentPath,&ffblk,DIRFLAGA);     // find all members+dirs

   strcpy (CurrentPath,drive);
   strcat (CurrentPath,dir);

   while (!done)
   {
      if (stopkey) break;

      if (!(ffblk.ff_attrib & FA_DIREC) )         // not directory file
       {   // process them as members now

	      if (!DidDir)                             // already did it
	      {
             DidDir = TRUE;
	          ProcessDirectory(CurrentPath,"",filename,ext);
	      }
       }
       else
       {  if (ffblk.ff_name[0] != '.')                 // not . or .. dirs
          {
	          strcpy (TempFileName,ffblk.ff_name);     // directory now
	          strcat (TempFileName,"\\");

	          ProcessVolume(CurrentPath,TempFileName,filename,ext);
	       }

       }
       done = (int2)findnext(&ffblk);

	    PeekMessage(&keymsg, 0, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE);

       if (keymsg.message == WM_KEYDOWN)
       {  if((UINT)keymsg.wParam == VK_ESCAPE )
          {
            if( Confirm(0, " Volume Scan Interrupted\n\n"
                         "Do you want to stop ?"))
		      stopkey = 1;
          }
       }
   }
   return NULL;
}


//----------------------------------------------------------------------
// search drives for stuff  (requires more room for long file names 1024 shld do it
// Right now progresses through all drives:\dir and then the rest
//----------------------------------------------------------------------

Bool AutoSearch()
{
   char  drivecheck [4] = {0};   // C:

   int  i,f;

   char  filename [260]= "*";  // 39 12345678 (260 win32)
   char  ext      [260]= {0};  // 43 .xxx     (260 win32)

   char  drivework [3] = "C:";   // C:

   int  currdrive;              // currently active drive
   int  drivesfound;
   int  SaveDrive;

   MSG   keymsg;
   UINT  Drivetype;

   //-------------------------------------------------------------------

   keymsg.message = 0;

   stopkey = 0;                  // reset user stop

   drivecheck[1]  = drivework[1];         // COLON     A=65, B=66, C=67 etc.
	drivecheck[2]  = char(92);          	// Backslash Char.

  hDlgSearch = CreateDialogParam(hWInst, "AutoSearch", hMainWindow, AutoSearchDlgProc, NULL);

  hList    = GetDlgItem(hDlgSearch, lst1);    //

   // look for current drive first
   currdrive    = getdisk();              // current drive 0, 1, 2, ...
   SaveDrive    = currdrive;

   drivesfound = setdisk(currdrive);   	// Number of logical drives in system
   if (!drivesfound) drivesfound=1;    	// ??????????


   //--------now search all the drives-- for this filename
   //

   for (i=0; i< drivesfound; i++)
   {    if (stopkey) break;                   // user interrupt

        drivework[0]  = char(i+'A');          // A=65, B=66, C=67 etc.
        drivecheck[0]  = char(i+'A');          // A=65, B=66, C=67 etc.

   Drivetype = GetDriveType(drivecheck);

        if (i > 1 && Drivetype == DRIVE_FIXED) // not A=0,B=1 not CD etc.
        {

         for(f=0; f<maxclean; f++)
          {
            lstrcpyn(ext,deletenames[f],4);		// Grab our extensions 1 at a time

   			Static_SetText(GetDlgItem(hDlgSearch, stc2), ext);

	         ProcessVolume(drivework,"\\",filename,ext);

	         PeekMessage(&keymsg, 0, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE);
           	if (keymsg.message == WM_KEYDOWN)
           	 {   if((UINT)keymsg.wParam == VK_ESCAPE )
               	{
                  		if( Confirm(0, " Volume Scan Interrupted\n\n"
		                               "Do you want to stop ?" ))
					          {   stopkey = 1;
                  		 }
               	}
           	 }
          }
        }					// If Valid Drive
   }							// Loop through ALL Drives
   setdisk(SaveDrive);  // root drive we started with (safety)
   chdir(RootDir);
   return FALSE;
}

//////////////////////////////////////
// The window proc is where messages get processed
//////////////////////////////////////

LRESULT CALLBACK EXPORT16 WndProc(HWND hWindow, UINT Message,
                                  WPARAM wParam, LPARAM lParam)
{
  switch(Message)
  {
    HANDLE_MSG(hWindow, WM_DESTROY, Q2_OnDestroy);
	 HANDLE_MSG(hWindow, WM_CREATE, 	Q2_OnCreate);
	 HANDLE_MSG(hWindow, WM_COMMAND, Q2_Command);
    default:
      return Window1_DefProc(hWindow, Message, wParam, lParam);
  }
}

/////////////////////////////////////////////////////////////////////////////
//  The Deep AutoSearch Dialog - MODELESS
/////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK AutoSearchDlgProc(DIALOG_PARAMS)
{
   switch (msg)
   {
    case WM_INITDIALOG:
      return TRUE;

    case WM_DESTROY:
      return TRUE;

    case WM_COMMAND:
	   break;

    default:
      break;
   }
   return FALSE;
}


//////////////////////////////////////////////////////////////////////////////
//  The Deep INPUT Text Dialog Procedure
//////////////////////////////////////////////////////////////////////////////
#pragma argsused
BOOL CALLBACK InputTxtDlgProc(DIALOG_PARAMS)
{
 LPDLG2OPTS lpd2;	// Our Long Pointer to Dialog Input 2 char strings

   switch( msg )
   {
      case WM_INITDIALOG:
      {                                         //  Save string pointer passed here
			SetWindowLong(hDlg, DWL_USER, lParam); // store our Pointer

         lpd2 = (LPDLG2OPTS)lParam;				   // grab it for our use

         Static_SetText( GetDlgItem( hDlg, stc2 ), lpd2->sz4 );
         Static_SetText( GetDlgItem( hDlg, stc3 ), lpd2->sz5 );
         Static_SetText( GetDlgItem( hDlg, stc4 ), lpd2->sz6 );
         Static_SetText( GetDlgItem( hDlg, stc5 ), lpd2->sz7 );

			Edit_SetText( GetDlgItem( hDlg, edt1 ), lpd2->sz3 );   // init string
         return TRUE;
      }

      // By request; exit dialogs on right button up
      case WM_RBUTTONUP:
   	  PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDCANCEL,(WORD)GetWindowLong(hDlg, GWL_ID)), 0); // jav 6-1-97 was OK
        break;
      case WM_LBUTTONUP:
		//PostMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDOK,(WORD)GetWindowLong(hDlg, GWL_ID)), 0);
        break;

      case WM_COMMAND:

       lpd2 = (LPDLG2OPTS)GetWindowLong(hDlg, DWL_USER);  	// grab our pointer

       switch LOWORD(wParam)
       {
         case IDCANCEL:
          EndDialog( hDlg, FALSE);
          return TRUE;

         case IDOK:                              // buffer  // # of chars
			 Edit_GetText( GetDlgItem( hDlg, edt1 ), lpd2->sz3, lpd2->i1+1 );   // init string GetWindowText has bug jav 1-5-97 needs+1 in length
          EndDialog( hDlg, TRUE);
          return TRUE;
		 }
       break;
   }
   return FALSE ;
}

//////////////////////////////////////////////////////////
//                                                      //
//  Input user string instead of numbers for a change   //
//                                                      //
//////////////////////////////////////////////////////////
//if (!InputUserText (hwnd, 3, name, UPPERCASE) ||  outname[0] == '\0') return;
#pragma argsused
Bool InputUserText( HWND hwnd, int2 itemwidth, char *data,Bool UpperCase)
{
   DLG2OPTS d2;
   char  tname  [260]= {0};


   ZeroMemory(&d2, sizeof(d2));

   strcpy(d2.sz3, data);

   strcpy(tname, deletenames[0]);
   strcat(tname, ", ");
   strcat(tname,deletenames[1]);
   strcat(tname, ", ");
   strcat(tname,deletenames[2]);
   strcat(tname, ", ");
   strcat(tname,deletenames[3]);

   strcpy(d2.sz4, tname);

   strcpy(tname, deletenames[4]);
   strcat(tname, ", ");
   strcat(tname,deletenames[5]);
   strcat(tname, ", ");
   strcat(tname,deletenames[6]);
   strcat(tname, ", ");
   strcat(tname,deletenames[7]);

   strcpy(d2.sz5, tname);


   strcpy(tname, deletenames[8]);
   strcat(tname, ", ");
   strcat(tname,deletenames[9]);
   strcat(tname, ", ");
   strcat(tname,deletenames[10]);
   strcat(tname, ", ");
   strcat(tname,deletenames[11]);

   strcpy(d2.sz6, tname);

   strcpy(tname, deletenames[12]);
   strcat(tname, ", ");
   strcat(tname,deletenames[13]);
   strcat(tname, ", ");
   strcat(tname,deletenames[14]);
   strcat(tname, ", ");
   strcat(tname,deletenames[15]);

   strcpy(d2.sz7, tname);

   d2.i1    = itemwidth;

   if( DialogBoxParam( hWInst, "InputTxt", hMainWindow, InputTxtDlgProc, (LPARAM)(LPDLG2OPTS)&d2 ) )
   {
       strncpy(data, d2.sz3, itemwidth);
       data[itemwidth] = '\0';              //  force delim max length
       if (UpperCase) strupr(data);         //
       return TRUE;
   }
   return FALSE;
}

//
//   FUNCTION: CenterWindow(HWND, HWND)
//
//   PURPOSE: Centers one window over another.
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
//       This functionwill center one window over another ensuring that
//    the placement of the window is within the 'working area', meaning
//    that it is both within the display limits of the screen, and not
//    obscured by the tray or other framing elements of the desktop.
BOOL CenterWindow (HWND hwndChild, HWND hwndParent)
{
   RECT    rChild, rParent, rWorkArea;
   int     wChild, hChild, wParent, hParent;
   int     xNew, yNew;
   BOOL  bResult;

   // Get the Height and Width of the child window
   GetWindowRect (hwndChild, &rChild);
   wChild = rChild.right - rChild.left;
   hChild = rChild.bottom - rChild.top;

   // Get the Height and Width of the parent window
   GetWindowRect (hwndParent, &rParent);
   wParent = rParent.right - rParent.left;
   hParent = rParent.bottom - rParent.top;

   // Get the limits of the 'workarea'
   bResult = SystemParametersInfo(
      SPI_GETWORKAREA,  // system parameter to query or set
      sizeof(RECT),
      &rWorkArea,
      0);
   if (!bResult) {
      rWorkArea.left = rWorkArea.top = 0;
      rWorkArea.right = GetSystemMetrics(SM_CXSCREEN);
      rWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN);
   }

   // Calculate new X position, then adjust for workarea
   xNew = rParent.left + ((wParent - wChild) /2);
   if (xNew < rWorkArea.left) {
      xNew = rWorkArea.left;
   } else if ((xNew+wChild) > rWorkArea.right) {
      xNew = rWorkArea.right - wChild;
   }

   // Calculate new Y position, then adjust for workarea
   yNew = rParent.top  + ((hParent - hChild) /2);
   if (yNew < rWorkArea.top) {
      yNew = rWorkArea.top;
   } else if ((yNew+hChild) > rWorkArea.bottom) {
      yNew = rWorkArea.bottom - hChild;
   }

   // Set it, and return
   return SetWindowPos (hwndChild, NULL, xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

